import * as pathModule from "path"
import { Flow } from "./lib/flow"
import { Context } from "./lib/context"

let context = new Context({
    apiPathes: [pathModule.join(__dirname, "../test-project/webapp/src/script/R.api.js")],
    host: "localhost",
    port: 10183
})

let flow = new Flow(context, [{
    name: "echo",
    data: {
        title: "TestName",
        content: "TestContent"
    },
    shouldBe: {
        name: "TestName",
        content: "TestContent"
    },
    example: {

    },
    save: {
        id: "postId"
    },
    check: {
        id: true
    }
}, {
    name: "echo",
    data: {
        title: "$post",
        content: "TestContent"
    },
    shouldBe: {
        name: "TestName",
        content: "TestContent"
    },
    example: {

    },
    save: {
        id: "postId"
    },
    check: {
        id: true
    }
}])


let result = flow.go((err) => {
    console.error(err)
})
