"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pathModule = require("path");
const flow_1 = require("./lib/flow");
const context_1 = require("./lib/context");
let path = process.argv[2];
console.log("Using ", path);
let context = new context_1.Context({
    apiPathes: [pathModule.join(__dirname, "../test-project/webapp/src/script/R.api.js")],
    host: "localhost",
    port: 10183
});
let flow = new flow_1.Flow(context, [{
        name: "echo",
        data: {
            title: "TestName",
            content: "TestContent"
        },
        shouldBe: {
            name: "TestName",
            content: "TestContent"
        },
        save: {
            id: "postId"
        },
        check: {
            id: true
        }
    }]);
let result = flow.go((err) => {
    console.error(err);
});
//# sourceMappingURL=example.typescript.js.map