import { Session } from "./session";
export declare class Action {
    session: Session;
    readonly info: ActionData;
    static actionsFromScriptRecursive(path: string): ActionData[];
    constructor(session: Session, info: ActionData);
    go(callback: (err?: Error) => void): void;
    check(data: any, check?: boolean | {
        [path: string]: Checker;
    } | ((v: any) => boolean)): boolean;
    should(data: any): void;
    solveResult(data: any): void;
}
export interface ActionData {
    name: string;
    data?: any;
    shouldBe?: {
        [path: string]: any;
    };
    example?: any;
    save?: {
        [path: string]: string;
    } | string;
    saveHeader?: {
        [path: string]: string;
    };
    check?: {
        [path: string]: Checker;
    } | Checker;
}
export declare type Checker = ((v: any) => boolean) | boolean;
