"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const action_1 = require("./action");
class Flow {
    constructor(context, todos) {
        this.context = context;
        this.todos = todos;
        this.responses = [];
    }
    go(callback) {
        let session = this.context.createSession();
        let actions = this.todos.map(item => new action_1.Action(session, item));
        // for each actions, action.go one by one, and finally returns(or error out at middle)
        this.next(actions, callback);
        return session;
    }
    next(actions, finish) {
        let next = actions.shift();
        if (!next) {
            finish(...this.responses[this.responses.length - 1]);
            return;
        }
        this.current = next;
        next.go((err, result) => {
            this.responses.push([err, result]);
            if (err) {
                console.error(next.info.name, "Failed:", err.message);
                finish(err);
                return;
            }
            this.next(actions, finish);
        });
    }
}
exports.Flow = Flow;
//# sourceMappingURL=flow.js.map