import { Action, ActionData } from "./action"
import { Context } from "./context"
export class Flow {
    constructor(public readonly context: Context, public readonly todos: ActionData[]) {
    }
    go(callback: (err?: Error, result?) => void) {
        let session = this.context.createSession()
        let actions = this.todos.map(item => new Action(session, item))

        // for each actions, action.go one by one, and finally returns(or error out at middle)

        this.next(actions, callback)
        return session
    }
    current: Action
    responses: any[] = []
    next(actions: Action[], finish: (err?: Error, data?: any) => void) {
        let next = actions.shift()
        if (!next) {
            finish(...this.responses[this.responses.length - 1])
            return
        }
        this.current = next
        next.go((err, result) => {
            this.responses.push([err, result])
            if (err) {
                console.error(next.info.name, "Failed:", err.message)
                finish(err)
                return
            }
            this.next(actions, finish)
        })
    }
}
