"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
class FlowTest {
    constructor(option) {
        this.flow = option.flow;
    }
    test(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            let result;
            for (let i in this.flow) {
                let item = this.flow[i];
                // let item = this.flow[i]
                let apiServiceName = Object.keys(item)[0];
                let apiName = Object.keys(item[apiServiceName])[0];
                if (!item[apiServiceName][apiName].path) {
                    item[apiServiceName][apiName].path = this.getAPISpec(apiServiceName, apiName).path;
                }
                if (item[apiServiceName][apiName].method) {
                    item[apiServiceName][apiName].method = this.getAPISpec(apiServiceName, apiName).method;
                }
                let APISpec = item[apiServiceName][apiName];
                try {
                    result = yield this.action(APISpec);
                }
                catch (e) {
                    callback(e, `${i} flow is error`);
                    return;
                }
                if (!this.deepCompare(result, item.return)) {
                    // callback error
                    callback(new Error("different"));
                    return;
                }
            }
            callback(null, result);
        });
    }
    // private trancformReturnToNextActionParams(option: { item: Model.APISpec, result: any }) {
    //     if (option.item.transform) {
    //         // transform
    //     }
    // }
    getAPISpec(APIServiceName, APIName) {
        // TODO
        let spec = {
            path: "",
            method: ""
        };
        return spec;
    }
    deepCompare(o1, o2, whiteList) {
        let flag = true;
        if (!(o1 instanceof Object) || !(o2 instanceof Object)) {
            flag = false;
            return flag;
        }
        if ((Object.keys(o1).length) != Object.keys(o2).length) {
            flag = false;
            return flag;
        }
        for (let k in o1) {
            if (whiteList.find((v) => {
                return v == k;
            })) {
                continue;
            }
            if (o1[k] instanceof Object && o2[k] instanceof Object) {
                this.deepCompare(o1[k], o2[k]);
            }
            else if (!(o1[k] instanceof Object) && !(o2[k] instanceof Object)) {
                if (o1[k] !== o2[k]) {
                    flag = false;
                    return flag;
                }
            }
            else {
                flag = false;
                return flag;
            }
        }
        return flag;
    }
    action(item) {
        return new Promise((resolve, reject) => {
            let query;
            let path = item.path;
            let body;
            let reg = /:[a-zA-z]+/;
            let requiredParams = item.path.match(reg);
            for (let param of requiredParams) {
                let a = param.slice(1);
                if (item.params[a]) {
                    item.path.replace(param, item.params[a]);
                    item.params;
                    delete item.params[a];
                }
            }
            for (let k in item.params) {
                body[k] = item.params[k];
            }
            // if (item.params.query) {
            //     let q = item.params.query
            //     let queryArr = []
            //     for (let k in q) {
            //         let item = `${k}=${q[k]}`
            //         queryArr.push(item)
            //     }
            //     let query = queryArr.join("&")
            //     path = `${path}?${query}`
            // }
            let option = {
                url: path,
                method: item.method,
                json: true,
                headers: {
                    "content-type": "application/json",
                },
                body: body
            };
            request.post(option, (err, res, body) => {
                if (err) {
                    reject(err);
                }
                resolve(body);
            });
        });
    }
}
exports.FlowTest = FlowTest;
//# sourceMappingURL=test.js.map