import * as Model from "./model"
import * as request from "request"
interface Callback<T> {
    (error?: Error, data?: T): void
}


export class FlowTest {
    constructor(option: {
        flow: Model.RouteSpecDefination[]
    }) {
        this.flow = option.flow
    }
    public flow: Model.RouteSpecDefination[]
    async test(callback) {
        let result
        for (let i in this.flow) {
            let item = this.flow[i]
            // let item = this.flow[i]
            let apiServiceName = Object.keys(item)[0]
            let apiName = Object.keys(item[apiServiceName])[0]
            if (!item[apiServiceName][apiName].path) {
                item[apiServiceName][apiName].path = this.getAPISpec(apiServiceName, apiName).path
            }
            if (item[apiServiceName][apiName].method) {
                item[apiServiceName][apiName].method = this.getAPISpec(apiServiceName, apiName).method
            }
            let APISpec = item[apiServiceName][apiName] as Model.APISpec
            try {
                result = await this.action(APISpec)
            }
            catch (e) {
                callback(e, `${i} flow is error`)
                return
            }
            if (!this.deepCompare(result, item.return)) {
                // callback error
                callback(new Error("different"))
                return
            }
        }
        callback(null, result)

    }
    // private trancformReturnToNextActionParams(option: { item: Model.APISpec, result: any }) {
    //     if (option.item.transform) {
    //         // transform
    //     }
    // }
    getAPISpec(APIServiceName: string, APIName: string) {
        // TODO
        let spec = {
            path: "",
            method: ""
        }
        return spec
    }
    deepCompare(o1: Object, o2: Object, whiteList?: Array<string>): boolean {
        let flag: boolean = true
        if (!(o1 instanceof Object) || !(o2 instanceof Object)) {
            flag = false
            return flag
        }
        if ((Object.keys(o1).length) != Object.keys(o2).length) {
            flag = false
            return flag
        }
        for (let k in o1) {
            if (whiteList.find((v) => {
                return v == k
            })) {
                continue
            }
            if (o1[k] instanceof Object && o2[k] instanceof Object) {
                this.deepCompare(o1[k], o2[k])
            } else if (!(o1[k] instanceof Object) && !(o2[k] instanceof Object)) {
                if (o1[k] !== o2[k]) {
                    flag = false
                    return flag
                }
            } else {
                flag = false
                return flag
            }
        }
        return flag;
    }


    private action(item: Model.APISpec) {
        return new Promise((resolve, reject) => {
            let query
            let path = item.path
            let body

            let reg = /:[a-zA-z]+/
            let requiredParams = item.path.match(reg)
            for (let param of requiredParams) {
                let a = param.slice(1)
                if (item.params[a]) {
                    item.path.replace(param, item.params[a])
                    item.params
                    delete item.params[a]
                }
            }
            for (let k in item.params) {
                body[k] = item.params[k]
            }
            // if (item.params.query) {
            //     let q = item.params.query
            //     let queryArr = []
            //     for (let k in q) {
            //         let item = `${k}=${q[k]}`
            //         queryArr.push(item)
            //     }
            //     let query = queryArr.join("&")
            //     path = `${path}?${query}`
            // }

            let option: ReqParams = {
                url: path,
                method: item.method,
                json: true,
                headers: {
                    "content-type": "application/json",
                },
                body: body
            }
            request.post(option, (err, res, body) => {
                if (err) {
                    reject(err)
                }
                resolve(body)
            })
        })
    }
}

interface ReqParams {
    url: string,
    method: string,
    json: true,
    headers: {
        "content-type": "application/json",
    },
    body: any
}